package dclap;

import java.applet.Applet;
import java.awt.*;

public class AppFrame extends Frame {
    protected Applet app;

    public AppFrame(Applet itsApp) {
        app = itsApp;
    }

    public AppFrame(Applet itsApp, String title) {
        super(title);
        app = itsApp;
    }

    public void closeWin() {
        app.postEvent(new Event(this, Event.WINDOW_DESTROY, null));
        dispose();      //  destroys menubar !
    }

    public boolean handleEvent(Event evt) {
        if (evt.id == Event.WINDOW_DESTROY) {
            closeWin();
            return true;
        }
        if (evt.id == Event.GOT_FOCUS) {
            app.postEvent(new Event(this, Event.GOT_FOCUS, null));
        }
        return super.handleEvent(evt);
    }

    public boolean action(Event ev, Object arg) {
        if ("Close".equals(arg)) {
            closeWin();
            return true;
        } else if (app.action(ev, arg))
            return true;
        else
            return super.action(ev, arg);
    }

}


