package gui;

// SciCalc.java

// compilation unit for the SCIENTIFIC CALCULATOR PROGRAM.


import java.applet.Applet;
import java.awt.*;

//import java.lang.Math;


/******************************************************************

// Applet representing the Calculator as a Single Unit

 ******************************************************************/


class KeyBoard extends Panel {


    Button keyBoardBtn[] = new Button[30];



    //the order in which button to be placed in keyboard

    int buttonOrder[] = {10, 9, 8, 11, 12, 7, 6, 5, 13, 14,

                         4, 3, 2, 15, 16, 1, 27, 17, 18, 19,

                         20, 21, 22, 23, 24, 25, 26, 0, 28, 29};

    //constructor

    public KeyBoard() {

        int i;



        // set layout as 6 * 5 table

        // 6 rows, 5 cols, width & height of each grid

        setLayout(new GridLayout(6, 5, 5, 5));



        // create 30 buttons and give them the label



        // create the first button (the mainkey "C" for cancel)

        keyBoardBtn[0] = new Button();

        keyBoardBtn[0].setLabel("C");



        // create 10 buttons for numbers 0-9.

        for (i = 1; i < 11; i++)

            keyBoardBtn[i] = new Button(String.valueOf(i - 1));



        //create the remaining buttons for function operators

        keyBoardBtn[11] = new Button("+");

        keyBoardBtn[12] = new Button("-");

        keyBoardBtn[13] = new Button("*");

        keyBoardBtn[14] = new Button("/");

        keyBoardBtn[15] = new Button("1/X");

        keyBoardBtn[16] = new Button("X^2");

        keyBoardBtn[17] = new Button("=");

        keyBoardBtn[18] = new Button("%");

        keyBoardBtn[19] = new Button("Mod");


        keyBoardBtn[20] = new Button("Sin");

        keyBoardBtn[21] = new Button("Cos");

        keyBoardBtn[22] = new Button("Tan");

        keyBoardBtn[23] = new Button("Sqrt");

        keyBoardBtn[24] = new Button("Exp");

        keyBoardBtn[25] = new Button("Log");

        keyBoardBtn[26] = new Button("Pow");

        keyBoardBtn[27] = new Button(".");

        keyBoardBtn[28] = new Button("Abs");

        keyBoardBtn[29] = new Button("+/-");





        // Now add 30 buttons to the Grid to display

        for (i = 0; i < 30; i++)

            add(keyBoardBtn[buttonOrder[i]]);

    }

}


public class SciCalc extends Applet {


    private int operation, lastButtonType, countOperation;


    private double onScreen, outOfScreen, decimalVal, intPart;


    private boolean isDot;


    private String fracPart, dispValue;



    // Display is the one which shows off the result of calculation

    private Label display;


    /*****************************

            OVER-RIDED METHOD - 1

    *****************************/


    public void init() {

        GridBagLayout GBL = new GridBagLayout();

        GridBagConstraints GBC = new GridBagConstraints();


        setLayout(GBL);

        resize(230, 260);


        setDisplay(new Label(String.valueOf(getOnScreen()), Label.RIGHT));

        GBC.fill = GridBagConstraints.BOTH;

        GBC.weightx = 1.0;

        GBC.weighty = 1.0;

        GBC.gridwidth = GridBagConstraints.REMAINDER;

        GBC.gridheight = 1;

        GBC.ipadx = 5;

        GBC.ipady = 5;

        GBL.setConstraints(getDisplay(), GBC);

        add(getDisplay());


        KeyBoard KB = new KeyBoard();

        GBC.weighty = 4.0;

        GBC.gridheight = 4;

        GBC.ipadx = 1;

        GBC.ipady = 1;

        GBL.setConstraints(KB, GBC);

        add(KB);


        resetCalculator();

    }


    /*****************************

            OVER-RIDED METHOD - 2

    *****************************/


    public Insets insets() {

        return new Insets(10, 10, 10, 10);

    }


    /*****************************

            OVER-RIDED METHOD - 3

    *****************************/


    public boolean handleEvent(Event e) {

        if (e.id == e.WINDOW_DESTROY) {
            hide();
            return true;
        }

        return super.handleEvent(e);

    }

    public boolean action(Event e, Object somebutton) {


        if (e.target instanceof Button) {


            String temp_string = (String) somebutton;


            if (temp_string.equals("C"))

                resetCalculator();

            else if (temp_string.equals("+"))

                setOperation(1);

            else if (temp_string.equals("-"))

                setOperation(2);

            else if (temp_string.equals("*"))

                setOperation(3);

            else if (temp_string.equals("/"))

                setOperation(4);

            else if (temp_string.equals("1/X")) {

                setOperation(5);

                doOperation();

            } else if (temp_string.equals("X^2")) {

                setOperation(6);

                doOperation();

            } else if (temp_string.equals("%")) {

                setOperation(7);

                doOperation();

            } else if (temp_string.equals("Mod")) {

                setOperation(8);

                //doOperation();

            } else if (temp_string.equals("Sin")) {

                setOperation(9);

                doOperation();

            } else if (temp_string.equals("Cos")) {

                setOperation(10);

                doOperation();

            } else if (temp_string.equals("Tan")) {

                setOperation(11);

                doOperation();

            } else if (temp_string.equals("Sqrt")) {

                setOperation(12);

                doOperation();

            } else if (temp_string.equals("Exp")) {

                setOperation(13);

                doOperation();

            } else if (temp_string.equals("Log")) {

                setOperation(14);

                doOperation();

            } else if (temp_string.equals("Pow")) {

                setOperation(15);

                //doOperation();

            } else if (temp_string.equals("+/-")) {

                setOperation(16);

                doOperation();

            } else if (temp_string.equals("Abs")) {

                setOperation(17);

                doOperation();

            } else if (temp_string.equals("=")) {

                doOperation();

                setCountOperation(0);

            } else if (temp_string.equals(".")) {

                setDot(true);

                if (getLastButtonType() == 0)

                    setIntPart(getOnScreen());

                else
                    setIntPart(0);


            } else {

                if (!isDot()) {

                    if (getLastButtonType() == 0) {

                        setOnScreen(getOnScreen() * 10 +

                                Double.valueOf(temp_string).doubleValue());

                        setDispValue(String.valueOf(getOnScreen()));


                    } else {


                        setOnScreen(Double.valueOf(temp_string).doubleValue());

                        setDispValue(String.valueOf(getOnScreen()));

                    }

                } else {

                    setFracPart(getFracPart() + temp_string);

                    setDecimalVal(Double.valueOf(String.valueOf(getIntPart())

                            + "." + getFracPart()).doubleValue());

                    setOnScreen(getDecimalVal());

                    setDispValue(String.valueOf(getIntPart()) + "." + getFracPart());


                }

                setLastButtonType(0);

            }


            getDisplay().setText(getDispValue());

            return true;

        } else
            return false;

    }


    void resetCalculator() {

        setOnScreen(0);

        setOutOfScreen(0);

        setDecimalVal(0);


        setIntPart(0);

        setOperation(0);

        setLastButtonType(0);

        setCountOperation(0);

        setDot(false);

        setFracPart(new String());

        setDispValue(String.valueOf(getOnScreen()));

    }


    void setOperation(int op) {

        setCountOperation(getCountOperation() + 1);

        if (getCountOperation() > 1)

            doOperation();

        setOutOfScreen(getOnScreen());

        setIntPart(0);

        operation = op;

        setLastButtonType(op);

        setDot(false);

        setFracPart(new String());

    }


    void doOperation() {


        if (getLastButtonType() != 19) {


// do for the first press of "=" button

// ie for different set of operations

// eg. 7+5=?*4=?/23=?........



            double temp;

            switch (getOperation()) {

                case 1:

                    temp = getOutOfScreen() + getOnScreen();

                    break;

                case 2:

                    temp = getOutOfScreen() - getOnScreen();

                    break;

                case 3:

                    temp = getOutOfScreen() * getOnScreen();

                    break;

                case 4:

                    temp = getOutOfScreen() / getOnScreen();

                    break;

                case 5:

                    temp = 1 / getOnScreen();

                    break;

                case 6:

                    temp = getOnScreen() * getOnScreen();

                    break;

                case 7:

                    temp = getOnScreen() / 100;

                    break;

                case 8:

                    temp = getOutOfScreen() % getOnScreen();

                    break;

                case 9:

                    temp = Math.sin(getOnScreen());

                    break;

                case 10:

                    temp = Math.cos(getOnScreen());

                    break;

                case 11:

                    temp = Math.tan(getOnScreen());

                    break;

                case 12:

                    temp = Math.sqrt(getOnScreen());

                    break;

                case 13:

                    temp = Math.exp(getOnScreen());

                    break;

                case 14:

                    temp = Math.log(getOnScreen());

                    break;

                case 15:

                    temp = Math.pow(getOutOfScreen(), getOnScreen());

                    break;

                case 16:

                    temp = getOnScreen() * -1;

                    break;

                case 17:

                    temp = Math.abs(getOnScreen());

                    break;

                case 18:

                default:

                    temp = 0;

                    break;

            }



//assign the current number press to outOfScreen

            setOutOfScreen(getOnScreen());



//assign new calculated value to onScreen

            setOnScreen(temp);


            setDispValue(String.valueOf(getOnScreen()));

        } else {


            //do for consecutive press of "=" button.

            //Note here the operation will be the same.

            //eg. 7+5=?=?=?.........



//Here the outOfScreen remains constant, and the onScreen keeps

//on changing depending on the number of "=" pressed.



            switch (getOperation()) {

                case 1:

                    setOnScreen(getOnScreen() + getOutOfScreen());

                    break;

                case 2:

                    setOnScreen(getOnScreen() - getOutOfScreen());

                    break;

                case 3:

                    setOnScreen(getOnScreen() * getOutOfScreen());

                    break;

                case 4:

                    setOnScreen(getOnScreen() / getOutOfScreen());

                    break;

                case 5:

                    setOnScreen(1 / getOnScreen());

                    break;

                case 6:

                    setOnScreen(getOnScreen() * getOnScreen());

                    break;

                case 7:

                    setOnScreen(getOnScreen() / 100);

                    break;

                case 8:

                    setOnScreen(getOnScreen() % getOutOfScreen());

                    break;

                case 9:

                    setOnScreen(Math.sin(getOnScreen()));

                    break;

                case 10:

                    setOnScreen(Math.cos(getOnScreen()));

                    break;

                case 11:

                    setOnScreen(Math.tan(getOnScreen()));

                    break;

                case 12:

                    setOnScreen(Math.sqrt(getOnScreen()));

                    break;

                case 13:

                    setOnScreen(Math.exp(getOnScreen()));

                    break;

                case 14:

                    setOnScreen(Math.log(getOnScreen()));

                    break;

                case 15:

                    setOnScreen(Math.pow(getOnScreen(), getOutOfScreen()));

                    break;

                case 16:

                    setOnScreen(getOnScreen() * -1);

                    break;

                case 17:

                    setOnScreen(Math.abs(getOnScreen()));

                    break;

                case 18:

                default:

                    setOnScreen(0);

                    break;


            }

            setDispValue(String.valueOf(getOnScreen()));

        }

        setLastButtonType(19);

    }

    public int getOperation() {
        return operation;
    }

    public int getLastButtonType() {
        return lastButtonType;
    }

    public void setLastButtonType(int lastButtonType) {
        this.lastButtonType = lastButtonType;
    }

    public int getCountOperation() {
        return countOperation;
    }

    public void setCountOperation(int countOperation) {
        this.countOperation = countOperation;
    }

    public double getOnScreen() {
        return onScreen;
    }

    public void setOnScreen(double onScreen) {
        this.onScreen = onScreen;
    }

    public double getOutOfScreen() {
        return outOfScreen;
    }

    public void setOutOfScreen(double outOfScreen) {
        this.outOfScreen = outOfScreen;
    }

    public double getDecimalVal() {
        return decimalVal;
    }

    public void setDecimalVal(double decimalVal) {
        this.decimalVal = decimalVal;
    }

    public double getIntPart() {
        return intPart;
    }

    public void setIntPart(double intPart) {
        this.intPart = intPart;
    }

    public boolean isDot() {
        return isDot;
    }

    public void setDot(boolean dot) {
        isDot = dot;
    }

    public String getFracPart() {
        return fracPart;
    }

    public void setFracPart(String fracPart) {
        this.fracPart = fracPart;
    }

    public String getDispValue() {
        return dispValue;
    }

    public void setDispValue(String dispValue) {
        this.dispValue = dispValue;
    }

    public Label getDisplay() {
        return display;
    }

    public void setDisplay(Label display) {
        this.display = display;
    }


}



