package ipl;

import vs.ColorConverter;


public class IYQ extends ColorConverter {

    double A[][] = {
        {0.299, 0.587, 0.114},
        {0.596, -0.274, -0.322},
        {0.211, 0.522, 0.311}
    };

    Mat3 rgb2iyqMat = new Mat3(A);
    Mat3 iyq2rgbMat = rgb2iyqMat.invert();

    public IYQ(ProcessPlane pp_) {
        super(pp_);
    }

    public int[] fromRGB() {
        double pel[];
        float r, g, b;

        for (int i = 0; i < fi.getLength(); i++) {
            pel = rgb2iyqMat.multiply(fi.r[i], fi.g[i], fi.b[i]);

            fi.r[i] = (float) pel[0];
            fi.g[i] = (float) pel[1];
            fi.b[i] = (float) pel[2];
            pp.setPixel(i, (int) pel[0], (int) pel[1], (int) pel[2], 255);
        }

        return (pp.pels);
    }

    public int[] toRGB() {

        double pel[];

        for (int i = 0; i < fi.r.length; i++) {

            pel = iyq2rgbMat.multiply(fi.r[i], fi.g[i], fi.b[i]);

            fi.r[i] = (float) pel[0];
            fi.g[i] = (float) pel[1];
            fi.b[i] = (float) pel[2];
            pp.setPixel(i, (int) pel[0], (int) pel[1], (int) pel[2], 255);

        }

        return (pp.pels);
    }

}







