package ipl;


///////////////////////////////////////////////////////////////////////////
// class for Vec, to store each vector(head,tail) with initial_slope
///////////////////////////////////////////////////////////////////////////

class Vec {
    public Slope initial_slope;
    Points head, tail;
    public boolean tail_is_empty;

    Vec() {
    }

    Vec(Points h) {
        head = h;
    }

    // Put new point to head
    public void addHead(Points p) {
        head = p;
    }

    // Put new point to tail
    public void addTail(Points t) {
        tail = t;
    }

// To get slope as initial_slope
    public void getSlope() {
        initial_slope = new
                Slope(head.x - tail.x, head.y - tail.y);
    } // getSlope

// To get dx,dy between head and new point
    public Slope find_dy_dx(Points p) {
        return (
                new Slope(head.x - p.x, head.y - p.y));
    } // find_dy_dx

// To decide if slope is acceptable by the vector
    public boolean isSlopeAcceptable(Points p) {
        if (tail_is_empty)
            return false;
        else
            return
                    initial_slope.isEqual(find_dy_dx(p));
    } // isSlopeAcceptable
} // class Vec



